/// <reference types="node" />
import { IncomingHttpHeaders } from 'http';
import { ResourceAttributes } from '@opentelemetry/resources';
import type { Attributes } from '@opentelemetry/api';
import type { NodeOptions, HighlightContext } from './types.js';
export declare const HIGHLIGHT_REQUEST_HEADER = "x-highlight-request";
export interface HighlightInterface {
    init: (options: NodeOptions) => void;
    stop: () => Promise<void>;
    isInitialized: () => boolean;
    parseHeaders: (headers: Headers | IncomingHttpHeaders | undefined) => HighlightContext;
    setHeaders: (headers: Headers | IncomingHttpHeaders | undefined) => void;
    runWithHeaders: <T>(headers: Headers | IncomingHttpHeaders | undefined, cb: () => T) => T;
    consumeError: (error: Error, secureSessionId?: string, requestId?: string, metadata?: Attributes) => void;
    recordMetric: (secureSessionId: string, name: string, value: number, requestId?: string, tags?: {
        name: string;
        value: string;
    }[]) => void;
    flush: () => Promise<void>;
    log: (message: any, level: string, secureSessionId?: string | undefined, requestId?: string | undefined, metadata?: Attributes) => void;
    consumeAndFlush: (error: Error, secureSessionId?: string, requestId?: string, metadata?: Attributes) => Promise<void>;
    setAttributes: (attributes: ResourceAttributes) => void;
    _debug: (...data: any[]) => void;
}
export declare const H: HighlightInterface;
//# sourceMappingURL=sdk.d.ts.map